/*
 * Copyright 2011 JBoss, by Red Hat, Inc
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *    http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.jboss.errai.codegen.control;

import org.jboss.errai.codegen.AbstractStatement;
import org.jboss.errai.codegen.BlockStatement;
import org.jboss.errai.codegen.BooleanExpression;

/**
 * @author Mike Brock <cbrock@redhat.com>
 * @author Christian Sadilek <csadilek@redhat.com>
 */
public abstract class AbstractConditionalBlock extends AbstractStatement {
  private BooleanExpression condition;
  private BlockStatement block;

  protected AbstractConditionalBlock(BooleanExpression condition) {
    this.condition = condition;
    this.block = new BlockStatement();
  }

  protected AbstractConditionalBlock(BooleanExpression condition, BlockStatement block) {
    this.condition = condition;
    this.block = block;
  }

  public BooleanExpression getCondition() {
    return condition;
  }

  public BlockStatement getBlock() {
    return block;
  }
}